#!/usr/bin/python
# -*- coding: utf-8 -*- 
#this file is part of VrrtepCLI.
#    Vrrtep CLI is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public Licence as published by
#    the Free Software Foundation, either version 3 of the Licence, or
#    (at your option) any later version.
#
#    Vrrtep CLI is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Vrrtep CLI.  If not, see <http://www.gnu.org/licenses/>
#This module is both a rhyme searcher and txt/html rhyming dictionary generator
import os, sys
#comment out next line for generator
def navRhyme(word):
#un-comment next line for generator
#def main():
	infilename = os.path.join(os.path.dirname(sys.argv[0]), "naviwords.txt")
	infile = open(infilename,"r")
	rhymdict = {}
	alist = []
	aplist = []
	aeplist = []
	arlist = []
	atlist = []
	awlist = []
	aylist = []
	aelist = []
	aklist = []
	awklist = []
	awkxlist = []
	akxlist = []
	awllist = []
	allist = []
	amlist = []
	awmlist = []
	awnlist = []
	anlist = []
	awnglist = []
	anglist = []
	a_list = []
	elist = []
	enlist = []
	englist = []
	eplist = []
	erlist = []
	eylist = []
	etlist = []
	eyklist = []
	ewlist = []
	eynglist = []
	ewklist = []
	eyplist = []
	e_list = []
	eklist = []
	ekxlist = []
	ellist = []
	emlist = []
	ilist = []
	ihlist = []
	iklist = []
	ihklist = []
	ikxlist = []
	illist = []
	ihllist = []
	imlist = []
	ihmlist = []
	ihnlist = []
	inlist = []
	ihnglist = []
	iplist = []
	ihplist = []
	irlist = []
	itlist = []
	ihtlist = []
	lllist = []
	olist = []
	oklist = []
	okxlist = []
	ollist = []
	omlist = []
	onlist = []
	onglist = []
	oplist = []
	orlist = []
	otxlist = []
	o_list = []
	rrlist = []
	ulist = []
	uklist = []
	ullist = []
	umlist = []
	unlist = []
	unglist = []
	uplist = []
	urlist = []
	utlist = []
	utxlist = []
	for line in infile:
		if line.strip()[-1] == "a":
			alist.append(line.strip())
		elif line.strip()[-2:] == "ä":
			aelist.append(line.strip())
		elif line.strip()[-2:] == "ay":
			aylist.append(line.strip())
		elif line.strip()[-2:] == "ak":
			aklist.append(line.strip())
		elif line.strip()[-3:] == "akx":
			akxlist.append(line.strip())
		elif line.strip()[-2:] == "al":
			allist.append(line.strip())
		elif line.strip()[-2:] == "am":
			amlist.append(line.strip())
		elif line.strip()[-2:] == "an":
			anlist.append(line.strip())
		elif line.strip()[-3:] == "ang":
			anglist.append(line.strip())
		elif line.strip()[-2:] == "ap":
			aplist.append(line.strip())
		elif line.strip()[-3:] == "äp":
			aeplist.append(line.strip())
		elif line.strip()[-2:] == "ar":
			arlist.append(line.strip())
		elif line.strip()[-2:] == "at":
			atlist.append(line.strip())
		elif line.strip()[-2:] == "aw":
			awlist.append(line.strip())
		elif line.strip()[-4:] == "awkx":
			awkxlist.append(line.strip())
		elif line.strip()[-3:] == "awk":
			awklist.append(line.strip())
		elif line.strip()[-3:] == "awl":
			awllist.append(line.strip())
		elif line.strip()[-3:] == "awm":
			awmlist.append(line.strip())
		elif line.strip()[-3:] == "awn":
			awnlist.append(line.strip())
		elif line.strip()[-4:] == "awng":
			awnglist.append(line.strip())
		elif line.strip()[-2:] == "a'":
			a_list.append(line.strip())
		elif line.strip()[-1] == "e":
			elist.append(line.strip())
		elif line.strip()[-2:] == "ey":
			eylist.append(line.strip())
		elif line.strip()[-3:] == "eyk":
			eyklist.append(line.strip())
		elif line.strip()[-4:] == "eyng":
			eynglist.append(line.strip())
		elif line.strip()[-3:] == "eyp":
			eyplist.append(line.strip())
		elif line.strip()[-2:] == "ek":
			eklist.append(line.strip())
		elif line.strip()[-3:] == "ekx":
			ekxlist.append(line.strip())
		elif line.strip()[-2:] == "el":
			ellist.append(line.strip())
		elif line.strip()[-2:] == "em":
			emlist.append(line.strip())
		elif line.strip()[-2:] == "en":
			enlist.append(line.strip())
		elif line.strip()[-3:] == "eng":
			englist.append(line.strip())
		elif line.strip()[-2:] == "ep":
			eplist.append(line.strip())
		elif line.strip()[-2:] == "er":
			erlist.append(line.strip())
		elif line.strip()[-2:] == "et":
			etlist.append(line.strip())
		elif line.strip()[-2:] == "ew":
			ewlist.append(line.strip())
		elif line.strip()[-3:] == "ewk":
			ewklist.append(line.strip())
		elif line.strip()[-2:] == "e'":
			e_list.append(line.strip())
		elif line.strip()[-1] == "i":
			ilist.append(line.strip())
		elif line.strip()[-2:] == "ì":
			ihlist.append(line.strip())
		elif line.strip()[-2:] == "ik":
			iklist.append(line.strip())
		elif line.strip()[-3:] == "ìk":
			ihklist.append(line.strip())
		elif line.strip()[-3:] == "ikx":
			ikxlist.append(line.strip())
		elif line.strip()[-3:] == "ìl":
			ihllist.append(line.strip())
		elif line.strip()[-2:] == "il":
			illist.append(line.strip())
		elif line.strip()[-2:] == "im":
			imlist.append(line.strip())
		elif line.strip()[-3:] == "ìm":
			ihmlist.append(line.strip())
		elif line.strip()[-2:] == "in":
			inlist.append(line.strip())
		elif line.strip()[-3:] == "ìn":
			ihnlist.append(line.strip())
		elif line.strip()[-4:] == "ìng":
			ihnglist.append(line.strip())
		elif line.strip()[-2:] == "ip":
			iplist.append(line.strip())
		elif line.strip()[-3:] == "ìp":
			ihplist.append(line.strip())
		elif line.strip()[-2:] == "ir":
			irlist.append(line.strip())
		elif line.strip()[-2:] == "it":
			itlist.append(line.strip())
		elif line.strip()[-3:] == "ìt":
			ihtlist.append(line.strip())
		elif line.strip()[-2:] == "ll":
			lllist.append(line.strip())
		elif line.strip()[-1] == "o":
			olist.append(line.strip())
		elif line.strip()[-2:] == "ok":
			oklist.append(line.strip())
		elif line.strip()[-3:] == "okx":
			okxlist.append(line.strip())
		elif line.strip()[-2:] == "ol":
			ollist.append(line.strip())
		elif line.strip()[-2:] == "om":
			omlist.append(line.strip())
		elif line.strip()[-2:] == "on":
			onlist.append(line.strip())
		elif line.strip()[-3:] == "ong":
			onglist.append(line.strip())
		elif line.strip()[-2:] == "op":
			oplist.append(line.strip())
		elif line.strip()[-2:] == "or":
			orlist.append(line.strip())
		elif line.strip()[-3:] == "otx":
			otxlist.append(line.strip())
		elif line.strip()[-2:] == "o'":
			o_list.append(line.strip())
		elif line.strip()[-2:] == "rr":
			rrlist.append(line.strip())
		elif line.strip()[-1] == "u":
			ulist.append(line.strip())
		elif line.strip()[-2:] == "uk":
			uklist.append(line.strip())
		elif line.strip()[-2:] == "ul":
			ullist.append(line.strip())
		elif line.strip()[-2:] == "um":
			umlist.append(line.strip())
		elif line.strip()[-2:] == "un":
			unlist.append(line.strip())
		elif line.strip()[-3:] == "ung":
			unglist.append(line.strip())
		elif line.strip()[-2:] == "up":
			uplist.append(line.strip())
		elif line.strip()[-2:] == "ur":
			urlist.append(line.strip())
		elif line.strip()[-2:] == "ut":
			utlist.append(line.strip())
		elif line.strip()[-3:] == "utx":
			utxlist.append(line.strip())
	rhymdict["a"]=alist
	rhymdict["ä"]=aelist
	rhymdict["ay"]=aylist
	rhymdict["ak"]=aklist
	rhymdict["akx"]=akxlist
	rhymdict["al"]=allist
	rhymdict["am"]=amlist
	rhymdict["an"]=anlist
	rhymdict["ang"]=anglist
	rhymdict["äp"]=aeplist
	rhymdict["ap"]=aplist
	rhymdict["ar"]=arlist
	rhymdict["at"]=atlist
	rhymdict["aw"]=awlist
	rhymdict["awkx"]=awkxlist
	rhymdict["awl"]=awllist
	rhymdict["awm"]=awmlist
	rhymdict["awn"]=awnlist
	rhymdict["awng"]=awnglist
	rhymdict["a'"]=a_list
	rhymdict["e"]=elist
	rhymdict["ey"]=eylist
	rhymdict["eyk"]=eyklist 
	rhymdict["eyng"]=eynglist
	rhymdict["eyp"]=eyplist 
	rhymdict["ek"]=eklist
	rhymdict["ekx"]=ekxlist 
	rhymdict["el"]=ellist 
	rhymdict["em"]=emlist
	rhymdict["en"]=enlist 
	rhymdict["eng"]=englist 
	rhymdict["ep"]=eplist 
	rhymdict["er"]=erlist 
	rhymdict["et"]=etlist 
	rhymdict["ew"]=ewlist
	rhymdict["ewk"]=ewklist
	rhymdict["e'"]=e_list
	rhymdict["i"]=ilist
	rhymdict["ì"]=ihlist
	rhymdict["ik"]=iklist
	rhymdict["ìk"]=ihklist
	rhymdict["ikx"]=ikxlist
	rhymdict["il"]=illist
	rhymdict["ìl"]=ihllist
	rhymdict["im"]=imlist
	rhymdict["ìm"]=ihmlist
	rhymdict["in"]=inlist
	rhymdict["ìn"]=ihnlist
	rhymdict["ip"]=iplist
	rhymdict["ìp"]=ihplist
	rhymdict["ir"]=irlist
	rhymdict["it"]=itlist
	rhymdict["ìt"]=ihtlist
	rhymdict["ll"]=lllist
	rhymdict["o"]=olist
	rhymdict["ok"]=oklist
	rhymdict["okx"]=okxlist
	rhymdict["ol"]=ollist
	rhymdict["om"]=omlist
	rhymdict["on"]=onlist
	rhymdict["ong"]=onglist
	rhymdict["op"]=oplist
	rhymdict["or"]=orlist
	rhymdict["otx"]=otxlist
	rhymdict["o'"]=o_list
	rhymdict["rr"]=rrlist
	rhymdict["u"]=ulist
	rhymdict["uk"]=uklist
	rhymdict["ul"]=ullist
	rhymdict["um"]=umlist
	rhymdict["un"]=unlist
	rhymdict["ung"]=unglist
	rhymdict["up"]=uplist
	rhymdict["ur"]=urlist
	rhymdict["ut"]=utlist
	rhymdict["utx"]=utxlist
#comment out next 15 lines for generator.
	if len(word) != 0:
		if word[-1] in rhymdict:
			for rhyme in rhymdict[word[-1]]:
				print unicode(rhyme+",","utf-8"),
		elif word[-5:] in rhymdict:
			for rhyme in rhymdict[word[-5:]]:
				print unicode(rhyme+",","utf-8"),
		elif word[-4:] in rhymdict:
			for rhyme in rhymdict[word[-4:]]:
				print unicode(rhyme+",","utf-8"),
		elif word[-3:] in rhymdict:
			for rhyme in rhymdict[word[-3:]]:
				print unicode(rhyme+",","utf-8"),
		elif word[-2:] in rhymdict:
			for rhyme in rhymdict[word[-2:]]:
				print unicode(rhyme+",","utf-8"),
	else:
		pass
#####--GENERATOR--######
#uncomment all following necessary lines to use the generator.
#	print """
#
#<html> 
#<head> 
#<meta http-equiv="content-type" content="text/html; charset=utf-8" /> 
#</head> 
#<body> 
#<h1>Na'vi Rhyming Dictionary</h1> 
#<h3>Based on Na'vi Dictionary v.11.863</h3> 
#<h4>Compiled by Tirea Aean on 18 May 2011</h4> 
#<hr> 
#*This dictionary's entries are not in alphabetical order...yet*<br>
#*Note that MANY more rhymes are possible with using suffixes and enclitic adpositions.*<br>
#<br> 
#>Use the Find function with Ctrl+F to search the page.<br> 
#>It is most useful to search for some specific heading such as em: or u:<br> 
#>It may also be very helpful if you are searching for the rhymes of a specific<br> 
#>>>word, to search the word with a comma attached after it.<br> 
#<hr> 
#<br> 
#"""
#	for i in range(len(rhymdict)): #required uncomment
#		print #required uncomment
		#for html
#		print '<br>'
		#for txt
#		print rhymdict.keys()[i]+':\n'
		#for html
#		print rhymdict.keys()[i]+':<br><br>'
#		for val in rhymdict.values()[i]: #required uncomment
#			print val+',',  #requred uncomment
		#for txt
#		print '\n\n'
		#for html
#		print '<br><br>'
	infile.close()
#un-commnet for generator
#main()
