#!/usr/bin/python
# -*- coding: utf-8 -*-
#This file is part of vrrtepCLI
#    Vrrtep CLI is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public Licence as published by
#    the Free Software Foundation, either version 3 of the Licence, or
#    (at your option) any later version.
#
#    Vrrtep CLI is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Vrrtep CLI.  If not, see <http://www.gnu.org/licenses/>
import random
import os, sys

def scramble(word):
    
    s=word
    st=[]
    #append chars of word to a splitlist
    for char in word:
        st.append(char)
        while "\xac" in st:
            st[st.index('\xc3')] = st[st.index('\xc3')] + st[st.index('\xac')]
            del(st[st.index('\xac')])
        while "\x8c" in st:
            st[st.index('\xc3')] = st[st.index('\xc3')] + st[st.index('\x8c')]
            del(st[st.index('\x8c')])
        while "\xa4" in st:
            st[st.index('\xc3')] = st[st.index('\xc3')] + st[st.index('\xa4')]
            del(st[st.index('\xa4')])
    n=0
    rst=[]
    #make a list same size as word, random ints as entries
    while n!=len(st):
        rno=random.randint(0,len(st)-1)
        if rst.count(rno)==0:
            rst.append(rno)
            n=n+1
    #print rst
    n=0
    ost=''
    #make a string of the the splitlist with indices = entries of rand int list
    while n!=len(st):
        ost=ost+ st[rst[n]]
        n=n+1
    return s,ost

def listscramble(lyst):
    st = lyst
    n=0
    rst=[]
    #make a list same size as word, random ints as entries
    while n!=len(st):
        rno=random.randint(0,len(st)-1)
        if rst.count(rno)==0:
            rst.append(rno)
            n=n+1
    #print rst
    n=0
    ost=[]
    #make a string of the the splitlist with indices = entries of rand int list
    while n!=len(st):
        ost.append(st[rst[n]])
        n=n+1
    return ost

def game():
    filename = os.path.join(os.path.dirname(sys.argv[0]), "naviwords.txt")
    file = open(filename,"r")
    wordlist = []
    for line in file:
        wordlist.append(line.strip())
    scramlist = listscramble(wordlist)
    count=0
    score=0
    for word in scramlist:
        if "ì" in word or "ä" in word:
            pass
        else:
            word,scr = scramble(word)
            print 'word: '+unicode(scr,"utf-8")+'\n'
            a = raw_input("vrrtep:> ")
            while a!= word and a!= "ans" and a!= "/quit" and a!= "/exit" and a != "/q":
                score -= 1
                print "\nKehe. :\\"+' score:',score,'\n'
                a = raw_input("vrrtep:> ")
            if a == word:
                score += 1
                print "\nSrane! >:D"+' score:',score,'\n'
            elif a == "ans":
                score -= 1
                print unicode(word,"utf-8")
                print "score:",score,'\n'
            elif a == "/quit" or a == "/exit" or a == "/q":
                break
            count += 1
        
    print 'score:',score
